/* Jeff Connelly 
* C8 HW #1 - Credit Card Types
 * 17 Oct 2002
 */

#include <apstring.h>

char cc_type(const apstring& account)
{
	int ind = 0;
	if (account.length() != 16)
	{
		return 'x';
	}

	switch(account[ind])
	{
	case '4': return 'V'; // VISA
	case '5': return 'M'; // MasterCard
	case '3': switch(account[++ind])
			  {
			  case '7': return 'A'; // American Express
			  default: return 'X'; 
			  }
	case '6': switch(account[++ind])
			  {
		      case '0': switch(account[++ind])
					    {
			            case '1': switch(account[++ind])
								  {
								  case '1': return 'D'; // Discover
								  default: return 'X';
								  }
						default: return 'X';
						}
			  default: return 'X';
			  }
	default: return 'X';
	}
	return 'X';
}

int main()
{
	apstring cc;

	while(1)
	{
		cout << "Enter 16-digit CC#, Control-Break to exit: ";
		cin >> cc;
		switch(cc_type(cc))
		{
		case 'V': cout << "Visa"; break;
		case 'M': cout << "MasterCard"; break;
		case 'A': cout << "AmEx"; break;
		case 'D': cout << "Discover"; break;
		case 'X': cout << "Invalid (explict)"; break;
		default: cout << "Unknown (implict)"; break;
		}
		cout << endl;
	}

	return 0;
}