/* Jeff Connelly
 * 05 Dec 2002
 * Address Book
 */

#include <iostream.h>
#include <apvector.h>
#include <apstring.h>
#include <stdlib.h>

struct ADDRESS
{
	apstring name;
	apstring address;
	apstring city;
	apstring state;
	int zip;
	apstring phone;
};

class XXX{};    // exquisite "except" exception class
istream& operator>>(istream& is, ADDRESS& addr);           // iostream operators
ostream& operator<<(ostream& os, const ADDRESS& addr);
istream& operator>>(istream& is, apvector<ADDRESS>& book);
ostream& operator<<(ostream& os, apvector<ADDRESS>& book);


int main()
{
	apvector<ADDRESS> book;

	cout << "Address Book Program" << endl;
	cout << "To get the value in brackets, just press enter." << endl;

	while(1)
	{
		cin >> book;
		if (book.length() == 0)    // no inputs, quit
			break;
		cout << book;
	}

	return 0;
}



// THERE IS NOTHING OF INTEREST BELOW THIS LINE
// --cut here--


















istream& operator>>(istream& is, ADDRESS& addr)
{
	apstring temp;

	cout << "Name [enter to quit]:    ";
	getline(is, addr.name); 
	if (!addr.name.length()) 
		throw XXX();   // XXX marker to end of list if no input
 
	cout << "Address [12345]:         ";
	getline(is, addr.address);
	if (!addr.address.length()) 
		addr.address = "12345 Noname Street";    // default street
	
	cout << "City [Yucaipa]:          ";
	getline(is, addr.city);
	if (!addr.city.length())
		addr.city = "Yucaipa";                   // default city

	cout << "State code [CA]:         ";
	getline(is, addr.state);
	
	if (!addr.state.length())
		addr.state = "CA";
	cout << "Zip code [92399]:        ";
	getline(is, temp); 
	addr.zip = atoi(temp.c_str());
	if (!addr.zip)
		addr.zip = 92399;

	cout << "Telephone [800-555-1212]: ";
	getline(is, addr.phone);
	if (!addr.phone.length())
		addr.phone = "800-555-1212";

	return is;
}

ostream& operator<<(ostream& os, const ADDRESS& addr)
{
	os << addr.name << endl
	   << "\t" << addr.address << endl
	   << "\t" << addr.city << ", " << addr.state << " " << addr.zip << endl
	   << "\t" << addr.phone << endl;
	return os;
}

// Input an entire book
istream& operator>>(istream& is, apvector<ADDRESS>& book)
{
	int i = 0;
	book.resize(i + 1);

	while(1)
	{
		cout << "-- entry #" << i + 1 << "--" << endl;
		try
		{
			cin >> book[i++];
		} catch (XXX xxx) {
			xxx;
			book.resize(i -= 1);
			break;
		}
		book.resize(i + 1);
	}
	return is;
}

// Output an entire book
ostream& operator<<(ostream& os, apvector<ADDRESS>& book)
{
	for(int i = 0; i < book.length(); i++)
	{
		cout << i + 1 << ".\t" << book[i];
	}
	return os;
}
