
#include <iostream.h>     // for [io]stream
#include <stdlib.h>       // for system
#include <float.h>        // for _finite
#include <math.h>         // for sqrt

// Cartesian point on a plane
struct POINT
{
	double x, y;
};

// Line segment defined by two finite points
struct LINE
{
	POINT p1, p2;
};

double slope(LINE);
double length(LINE line);
void midpoint(LINE line);

int main()
{
	LINE L;
	double m;


	cout << "Line Slope Program" << endl;

	for(;;)
	{
		cout << "first point" << endl;
		cin >> L.p1.x >> L.p1.y;
		cout << "second point" << endl;
		cin >> L.p2.x >> L.p2.y;

		if (L.p1.x == L.p2.x && L.p1.y == L.p2.y)
		{
			cout << "ERROR two identical points entered!" << endl;
			continue;
		}

		cout << endl << 
			    "The slope of the line is:    ";
		m = slope(L);
		if (L.p1.x == L.p2.x)
			cout << "undefined (vertical line x=" << (L.p1.x) << ")";
		else
			cout << m;
		cout << endl;

		
		cout << "Length of the line segment:  " << length(L) << endl;
		cout << "The midpoint of the line is: "; midpoint(L);
		cout << endl << endl;
		// cin >> runagain
	}
	
	return 0;
}

void midpoint(LINE line)
{
	POINT pt;
	cout << "(" << (line.p1.x + line.p2.x) / 2;
	cout << " ," << (line.p1.y + line.p2.y) / 2 << ")" << endl;

}

double length(LINE line)
{
	return sqrt((line.p2.x - line.p1.x) * (line.p2.x - line.p1.x) +
		(line.p2.y - line.p1.y) * (line.p2.y - line.p1.y));
}

double slope(LINE line)
{
	return (line.p2.y - line.p1.y) / (line.p2.x - line.p1.x);
}
