/* Jeff Connelly
 * Ch 12 Lab 2
 * strlen, strcpy, strcat, strcmp
 */

#include <iostream.h>
#include <apstring.h>

// Return TRUE if program should be ran again
int check_runagain(char* str)
{
	char a[1];
	strcpy(a, str);
	return a[0] == 'y';
}

void abc()
{
	cout << "it worked" << endl;
	return;
}

int main()
{
	apstring str1, str2; 
	char *sz1, *sz2;
	char runagain[1];

	do
	{
		cout << "C-String and AP-String Function Demonstration + Buffer Overflow Example" << endl
			 << endl
			 << "You will be asked to enter two strings which will be used throughout the " << endl
			 << "demonstration. Please enter them now. (This program contains numerous" << endl
			 << "examples of serious security holes. Entering B longer than A is one.)" << endl
			 << endl;
		cout << "String A: ";
		getline(cin, str1);
		cout << "String B: ";
		getline(cin, str2);

		sz1 = (char*)str1.c_str();
		sz2 = (char*)str2.c_str();

		cout << "sz1: " << sz1 << endl
			 << "sz2: " << sz2 << endl;

		cout << endl;
		cout << "--- string length functions ---" << endl;
		cout << "String\tstrlen(s)\tapstring::length()" << endl;
		cout << "     A\t" << strlen(sz1) << "\t\t" << str1.length() << endl;
		cout << "     B\t" << strlen(sz2) << "\t\t" << str2.length() << endl;
		cout << endl;

		cout << "--- string concatenation functions ---" << endl;
		cout << "str1 + str2 = " << str1 + str2 << endl;
		cout << "strcat(sz1, sz2) = " << strcat(sz1, sz2) << endl;
		cout << endl;

		cout << "--- string comparison functions ---" << endl;
		cout << "str1 == str2 = " << (str1 == str2) << "\t" <<
			((str1 == str2) ? "true" : "false") << endl;
		cout << "strcmp(sz1, sz2) = " << strcmp(sz1, sz2) << "\t";
		if (strcmp(sz1, sz2) == 0)
			cout << "identical";
		else if (strcmp(sz1, sz2) > 0)
			cout << "greater";
		else
			cout << "less";
		cout << endl;

		cout << "--- string copying functions --" << endl;
		cout << "str1 = str2 = " << (str1 = str2) << endl;
		strcpy(sz2, sz1);
		cout << "strcpy(sz1, sz2), sz2 = " << sz1 << endl;

		
		//            nop nop nop  nop nop nop  CRASH      EIP       EBX
		//char b[] = "\x90\x90\x90\x90\x90\x90\xcd\x10\xd4\xfd\x64\0xxxxxxxx";
		//           144  144 144  144 144 144 205 16  212 253 100 0
		//                                            228e4  fd  64
		int ra_addr = (int)&runagain;

		cout << endl;
		cout << "(Hidden buffer overflow. Use of strcpy() in check_runagain." << endl;
		cout << "To activate, type:" << endl;
		cout << "-(2)Alt-205, Alt-16 to CRASH (int 0x10)  -or-" << endl;
		cout << "    Alt-235, Alt-254 (jmp $) to FREEZE" << endl;
		cout << "-(6)Alt-144 six times (NOP NOP NOP NOP NOP NOP) to fill 8 bytes" << endl;
		cout << "-(4)Alt-" << (ra_addr & 0xFF) << ", Alt-" << ((ra_addr & 0xFF00) >> 8) <<
			", Alt-" << ((ra_addr & 0xFF0000) >> 16) << "(" << ra_addr << ")" << endl;
		cout << "Run again (" << &runagain << ")? ";
		cin >> runagain;
		cin.ignore(80, '\n');
	} while(check_runagain(runagain));
	return 0;
}
