/* Circle Area and Circumference*/
/* Copyright (C) 2003-01-13 Jeff Connelly */

#include <iostream.h>      // input and output, in streams
#include <apstring.h>      // for apstring

#include "circle.h"        // class Circle, declaration
#include "circle.cpp"      // usually, this would be compiled separately


/* 1. Break circle.h into circle.h and circle.cpp
 * 2. add member function for circumference
 * 3. document (explain) each line of code in the entire class
 * 4. write a small program that accepts radii from user, then calculates circ
 */

int main()
{
	Circle k;              // instanciate an instance of the Circle class, a new object
	double radius;         // immediate radius retreived from the user via cin
	apstring str;          // stringified form of radius

	cout << "Circle Radius-Area-Circumference-Diameter Lab. Strike Control-C to exit." 
		 << endl << endl;  // banner

	do
	{
		// Ask for radius
		cout << "Radius [0]: ";
		getline(cin, str);
		radius = atof(str.c_str());

		// Set radius
		k.SetRadius(radius);

		// Calculate various requested information
		cout << "Radius: " << radius << endl
		     << "Area: " << k.Area() << endl 
             << "Circumference: " << k.Circumference() << endl
  			 << "Diameter: " << k.Diameter() << endl << endl;
	} while(1);

	return 0;
}